PROGRAM train;
(* Programa: TINS'06
 * Archivo: train.pas
 * Descripcin: Archivo inicial.
 * Autor: uo Martnez <niunio at pagina.de>
 *)

USES
  ayuda, error, mgMouse, mingro, reloj, sysutils, terreno;



TYPE
  NIVEL = RECORD
    Tamanno, Tiempo, Rectas, Curvas, Cruces, Muertas, Vacas: INTEGER;
  END;



VAR
  Tiles, Titulo, Logo, Allegro: MG_BITMAPptr;
  AreaJuego: ARENA;
  DobleBuffer: MG_BITMAPptr;
  MusicaPresentacion, MusicaJuego, MusicaGana, MusicaPierde: MG_MIDIptr;
  Niveles: ARRAY OF NIVEL;



(* Inicializa:
 *   Prepara el programa para empezar. *)
  FUNCTION Inicializa: BOOLEAN;

    PROCEDURE LeeNiveles;
    BEGIN
      SetLength (Niveles, 9);
      Niveles[0].Tamanno := 3;
      Niveles[0].Tiempo  := 1;
      Niveles[0].Rectas  := 3;
      Niveles[0].Curvas  := 3;
      Niveles[0].Cruces  := 2;
      Niveles[0].Muertas := 0;
      Niveles[0].Vacas   := 0;
      Niveles[1].Tamanno := 3;
      Niveles[1].Tiempo  := 1;
      Niveles[1].Rectas  := 2;
      Niveles[1].Curvas  := 2;
      Niveles[1].Cruces  := 2;
      Niveles[1].Muertas := 2;
      Niveles[1].Vacas   := 0;
      Niveles[2].Tamanno := 3;
      Niveles[2].Tiempo  := 1;
      Niveles[2].Rectas  := 2;
      Niveles[2].Curvas  := 2;
      Niveles[2].Cruces  := 0;
      Niveles[2].Muertas := 2;
      Niveles[2].Vacas   := 2;
      Niveles[3].Tamanno := 3;
      Niveles[3].Tiempo  := 1;
      Niveles[3].Rectas  := 2;
      Niveles[3].Curvas  := 2;
      Niveles[3].Cruces  := 0;
      Niveles[3].Muertas := 0;
      Niveles[3].Vacas   := 4;
      Niveles[4].Tamanno := 4;
      Niveles[4].Tiempo  := 1;
      Niveles[4].Rectas  := 4;
      Niveles[4].Curvas  := 4;
      Niveles[4].Cruces  := 3;
      Niveles[4].Muertas := 4;
      Niveles[4].Vacas   := 0;
      Niveles[5].Tamanno := 4;
      Niveles[5].Tiempo  := 1;
      Niveles[5].Rectas  := 4;
      Niveles[5].Curvas  := 4;
      Niveles[5].Cruces  := 0;
      Niveles[5].Muertas := 4;
      Niveles[5].Vacas   := 3;
      Niveles[6].Tamanno := 5;
      Niveles[6].Tiempo  := 1;
      Niveles[6].Rectas  := 5;
      Niveles[6].Curvas  := 10;
      Niveles[6].Cruces  := 4;
      Niveles[6].Muertas := 5;
      Niveles[6].Vacas   := 0;
      Niveles[7].Tamanno := 5;
      Niveles[7].Tiempo  := 1;
      Niveles[7].Rectas  := 4;
      Niveles[7].Curvas  := 10;
      Niveles[7].Cruces  := 0;
      Niveles[7].Muertas := 5;
      Niveles[7].Vacas   := 5;
      Niveles[8].Tamanno := 5;
      Niveles[8].Tiempo  := 1;
      Niveles[8].Rectas  := 4;
      Niveles[8].Curvas  := 5;
      Niveles[8].Cruces  := 0;
      Niveles[8].Muertas := 7;
      Niveles[8].Vacas   := 8;
    END;
  
  VAR
    Pal: MG_COLOR_PALETTE;
  BEGIN
    Inicializa := FALSE; { En principio, no funciona. }
    IF NOT mgStartup THEN
    BEGIN
      WriteLN ('Can''t start Allegro!');
      EXIT;
    END;
    IF NOT mgSetGfxModeEx (640, 480, 24, TRUE) THEN
    BEGIN
      WriteLN ('Can''t open graphics!');
      EXIT;
    END;
    DobleBuffer := mgCreateBitmap (640, 480);
    IF DobleBuffer = NIL THEN
      RAISE EXCEPTION.Create ('Can''t create double buffer!');
    IniciaReloj;
  { Carga niveles. }
    LeeNiveles;
  { Carga los grficos. }
    Tiles := mgLoadBitmap ('tiles.pcx', Pal);
    IF Tiles = NIL THEN
    BEGIN
      MensajeError ('Can''t load "tiles.pcx"');
      EXIT;
    END;
    Titulo := mgLoadBitmap ('titulo.pcx', Pal);
    IF Titulo = NIL THEN RAISE EXCEPTION.Create ('Can''t load "titulo.pcx"!');
    Logo := mgLoadBitmap ('burdjia.pcx', Pal);
    IF Logo = NIL THEN RAISE EXCEPTION.Create ('Can''t load "burdjia.pcx"!');
    Allegro := mgLoadBitmap ('allegro.pcx', Pal);
    IF Allegro = NIL THEN RAISE EXCEPTION.Create ('Can''t load "allegro.pcx"!');
  { Carga msica. }
    MusicaPresentacion := mgLoadMidi ('presenta.mid');
    MusicaJuego := mgLoadMidi ('juego.mid');
    MusicaGana := mgLoadMidi ('gana.mid');
    MusicaPierde := mgLoadMidi ('pierde.mid');
    Randomize;
    mgInitMouse; mgShowMouse (mgScreen);
  { Si lleg hasta aqu es que todo va bien. }
    Inicializa := TRUE;
  END;



(* Finaliza:
 *   Libera recursos y dems... *)
  PROCEDURE Finaliza;
  BEGIN
    IF AreaJuego <> NIL THEN AreaJuego.Destroy;
    IF Tiles <> NIL THEN mgDestroyBitmap (Tiles);
    IF Titulo <> NIL THEN mgDestroyBitmap (Titulo);
    IF Logo <> NIL THEN mgDestroyBitmap (Logo);
    IF Allegro <> NIL THEN mgDestroyBitmap (Allegro);
    IF DobleBuffer <> NIL THEN mgDestroyBitmap (DobleBuffer);
    IF MusicaPresentacion <> NIL THEN mgDestroyMidi (MusicaPresentacion);
    IF MusicaJuego <> NIL THEN mgDestroyMidi (MusicaJuego);
    IF MusicaGana <> NIL THEN mgDestroyMidi (MusicaGana);
    IF MusicaPierde <> NIL THEN mgDestroyMidi (MusicaPierde);
  END;



(* Partida:
 *   Desarrollo de una partida. *)
  PROCEDURE Partida;
  VAR
    Aborta: BOOLEAN;

  (* BucleJuego:
   *   Desarrolla el bucle de juego. *)
    PROCEDURE BucleJuego;
    VAR
      mX, mY, mB, oB: INTEGER; { Estado del ratn. }
      Tecla: INTEGER;

      PROCEDURE Marcadores;
      BEGIN
        mgRectFill (DobleBuffer, 500, 64, 600, 98, mgcolor (0, 0, 128));
        mgRect     (DobleBuffer, 502, 66, 598, 96, mgcolor (255, 255, 255));
        mgRect     (DobleBuffer, 503, 67, 597, 95, mgcolor (255, 255, 255));
	mgTextout  (DobleBuffer, mgDefaultFont, 518, 72,
		    mgColor (255, 255, 255), 'Stations');
	mgTextout  (DobleBuffer, mgDefaultFont, 546, 84,
		    mgColor (255, 255, 255),
		    IntToStr (AreaJuego.NumEstaciones));
      END;

    BEGIN
      oB := 0; Fotograma := 0;
      AreaJuego.DibujaFondo (DobleBuffer);
      mgShowMouse (DobleBuffer); mgClearKeybuf;
      REPEAT
	WHILE Fotograma > 0 DO
	BEGIN
	{ Automatismo. }
	  AreaJuego.Actualiza;
	{ Entrada del usuario. }
	  IF mgKeyPressed THEN
	  BEGIN
	    Tecla := mgReadkey SHR 8;
	    IF Tecla = MG_KEY_F1 THEN
	    BEGIN
	      MuestraAyuda;
	      Fotograma := 0;
	    END;
	    Aborta := Tecla = MG_KEY_ESC;
	  END;
	  mgGetMousePosition (mX, mY, mB);
	  IF (mB <> oB) AND (mB <> 0) THEN
	  BEGIN
	    AreaJuego.PosACasilla (mX, mY, mX, mY);
	    IF (mgKeyShifts AND MG_KB_CTRL_FLAG) <> 0 THEN
	      AreaJuego.DesplazaCasillas (mX, mY)
	    ELSE
	      AreaJuego.GiraCasilla(mX, mY,
				    (mgKeyShifts AND MG_KB_ALT_FLAG) = 0);
	  END;
	  oB := mB;
	{ Control de fotogramas. }
	  DEC (Fotograma);
	  IF Fotograma > (FPS / 3) THEN
	    RAISE EXCEPTION.Create ('Your computer is too slow!');
	END;
      { Actualiza grficos. }
	mgShowMouse (NIL);
	AreaJuego.Dibuja (DobleBuffer);
	Marcadores;
	mgShowMouse (DobleBuffer);
	mgBlit (DobleBuffer, mgScreen, 0, 0);
      UNTIL AreaJuego.FinJuego OR Aborta;
      mgShowMouse (NIL);
    END;

    PROCEDURE Gana;
    BEGIN
      mgPlayMIDI (MusicaGana, FALSE);
      mgRectFill (mgScreen, 220, 200, 420, 300, mgColor (0, 128, 0));
      mgRect     (mgScreen, 222, 202, 418, 298, mgColor (255, 255, 255));
      mgRect     (mgScreen, 223, 203, 417, 297, mgColor (255, 255, 255));
      mgTextOut  (mgScreen, mgDefaultFont, 300, 250, mgColor (255, 255, 255),
		  'Done!');
      mgSleep (6000);
    END;

    PROCEDURE Pierde;
    BEGIN
      mgPlayMIDI (MusicaPierde, FALSE);
      mgRectFill (mgScreen, 220, 200, 420, 300, mgColor (128, 0, 0));
      mgRect     (mgScreen, 222, 202, 418, 298, mgColor (255, 255, 255));
      mgRect     (mgScreen, 223, 203, 417, 297, mgColor (255, 255, 255));
      mgTextOut  (mgScreen, mgDefaultFont, 284, 250, mgColor (255, 255, 255),
		  'Derailed!');
      mgSleep (8000);
    END;

    PROCEDURE MarcaNivel (Nivel: INTEGER);
    BEGIN
      mgRectFill (mgScreen, 220, 200, 420, 300, mgColor (128, 0, 0));
      mgRect     (mgScreen, 222, 202, 418, 298, mgColor (255, 255, 255));
      mgRect     (mgScreen, 223, 203, 417, 297, mgColor (255, 255, 255));
      mgTextOut  (mgScreen, mgDefaultFont, 288, 250, mgColor (255, 255, 255),
		  'Level '+ IntToStr (Nivel));
      mgSleep (3000);
    END;
    
{ PROCEDURE Partida; }
  VAR
    Nivel, NdxNivel, Velocidad: INTEGER;
  BEGIN
    Aborta := FALSE;
    Nivel := 1; NdxNivel := 0; Velocidad := 1;
    REPEAT
      mgPlayMIDI (MusicaJuego, TRUE);
      AreaJuego.NuevoTerreno (
	Niveles[NdxNivel].Tamanno,
	Niveles[NdxNivel].Tiempo DIV Velocidad,
	Velocidad,
	Niveles[NdxNivel].Rectas,
	Niveles[NdxNivel].Curvas,
	Niveles[NdxNivel].Cruces,
	Niveles[NdxNivel].Muertas,
	Niveles[NdxNivel].Vacas
      );
      AreaJuego.DibujaFondo (mgScreen);
      AreaJuego.Dibuja (mgScreen);
      MarcaNivel (Nivel);
      BucleJuego;
      IF NOT Aborta THEN
      BEGIN
	IF AreaJuego.Gana THEN
	BEGIN
	  Gana;
	  INC (Nivel); INC (NdxNivel);
	  IF Nivel = 9 THEN
	  BEGIN
	    Velocidad := Velocidad * 2;
	    NdxNivel := 0;
	  END;
	END
	ELSE BEGIN
	  Pierde;
	  Aborta := TRUE;
	END;
      END;
      mgClearKeybuf;
    UNTIL Aborta;
  END;



(* Presentacion:
 *   Pantalla de presentacin, entrada y salida.  Devuelve TRUE para jugar. *)
  FUNCTION  Presentacion: BOOLEAN;
  CONST
  { Texto que muestra el visor. }
    TXT1 = '        _     +---------------------+    +-------------------+    +---------------------+  ';
    TXT2 = '  _U_n_|(     | Press F1 to help... |    | Press Esc to exit |    | Press Space to play |  ';
    TXT3 = ' (_____|_|-||-+---------------------+-||-+-------------------+-||-+---------------------+-|';
    TXT4 = '/_oo=00=oo       O=O           O=O          O=O         O=O         O=O            O=O     ';
  VAR
    PosX: INTEGER;
    Pantalla: MG_BITMAPptr;

  (* Visor:
   *   Realiza una animacin al estilo de las marquesinas rodantes.
   *   Es el ASCII art. *)
    PROCEDURE Visor;
    BEGIN
      IF Fotograma > 5 THEN
      BEGIN
      { Compara con -780 porque el contenido de la marquesina mide 744. }
        DEC (PosX, 8); IF PosX < -780 THEN PosX := 496;
	mgClearBitmapToColor (Pantalla, mgColor (51, 0, 0));
	mgTextout (Pantalla, mgDefaultFont, PosX, 0, mgColor (204, 0, 0), TXT1);
	mgTextout (Pantalla, mgDefaultFont, PosX, 8, mgColor (204, 0, 0), TXT2);
	mgTextout (Pantalla, mgDefaultFont, PosX, 16, mgColor (204, 0, 0), TXT3);
	mgTextout (Pantalla, mgDefaultFont, PosX, 24, mgColor (204, 0, 0), TXT4);
	mgBlit (Pantalla, mgScreen, 72, 340);
        Fotograma := 0;
      END;
    END;
    
  { FUNCTION  Presentacion: BOOLEAN; }
  VAR
    X, Y, Tecla: INTEGER;
  BEGIN
    TRY
      Pantalla := mgCreateBitmap (496, 32);
      IF Pantalla = NIL THEN RAISE EXCEPTION.Create ('Can''t create intro!');
      mgShowMouse (NIL); { Nos aseguramos de que no se ve el ratn. }
      FOR X := 0 TO 64 DO FOR Y := 0 TO 8 DO
	mgBlitEx (Tiles, mgScreen, 128, 192, X * 64, Y * 64, 64, 64);
      mgDrawSprite (mgScreen, Titulo, 62, 20);
      mgBlit (Logo, mgScreen, 400, 415);
      mgBlit (Allegro, mgScreen, 580, 400);
      mgTextOut (mgScreen, mgDefaultFont, 10, 416, mgColor (255, 255, 255),
                 '(c) uo Martnez, 2006');
      mgTextOut (mgScreen, mgDefaultFont, 10, 424, mgColor (255, 255, 255),
		 'Visit http://amarillion.bafsoft.net/tins06');
      mgTextOut (mgScreen, mgDefaultFont, 10, 432, mgColor (255, 255, 255),
		 'Visit http://alleg.sourceforge.net for Allegro');
      mgTextOut (mgScreen, mgDefaultFont, 10, 440, mgColor (255, 255, 255),
		 'Visit http://www.burdjia.com for final version');
      PosX := 496; Fotograma := 0; Tecla := 0;
      mgPlayMIDI (MusicaPresentacion, TRUE);
      WHILE (Tecla <> MG_KEY_SPACE) AND (Tecla <> MG_KEY_ESC) DO
      BEGIN
        Visor;
	IF mgKeyPressed THEN
       	BEGIN
	  Tecla := mgReadkey SHR 8;
	  IF Tecla = MG_KEY_F1 THEN MuestraAyuda;
	END;
      END;
      Presentacion := (Tecla = MG_KEY_SPACE);
    FINALLY
      mgStopMIDI;
      IF Pantalla <> NIL THEN mgDestroyBitmap (Pantalla);
    END;
  END;



(****************************
 * El programa empieza aqu *
 ****************************)
BEGIN
  IF Inicializa THEN
  TRY
  { Creamos la arena aqu para manejar las excepciones. }
    AreaJuego := ARENA.Create (Tiles);
  { Bucle principal del programa. }
    WHILE Presentacion DO
      Partida;
  EXCEPT
    ON Error: EXCEPTION DO MensajeError (Error.Message);
  END;
  Finaliza;
END.

